unified preinit environment

SVN-Revision: 7173
v19.07.3_mercusys_ac12_duma
Mike Baker 17 years ago
parent 862103b039
commit 4a41439c46

@ -79,8 +79,6 @@ ramoverlay() {
}
[ "$1" = "switch2jffs" ] && {
mtd erase "$partname"
# try to avoid fs changing while copying
mount -o remount,ro none / 2>&-
@ -103,8 +101,6 @@ ramoverlay() {
# this will almost always fail
umount /tmp/root 2>&-
# fs is clean
jffs2root --clean
exit 0
}

@ -0,0 +1,5 @@
#!/bin/sh
# Copyright (C) 2006 OpenWrt.org
set_state() {
}

@ -1,6 +1,20 @@
#!/bin/sh
# Copyright (C) 2006 OpenWrt.org
export PATH=/bin:/sbin:/usr/bin:/usr/sbin
. /etc/diag.sh
failsafe() {
lock /tmp/.failsafe
ash --login
}
[ -e /etc/preinit.arch ] && . /etc/preinit.arch
set_state preinit
mount_root ${FAILSAFE:+failsafe}
eval ${FAILSAFE:+failsafe}
lock -w /tmp/.failsafe
exec /sbin/init

@ -3,9 +3,10 @@
. /etc/functions.sh
mount none /proc -t proc
size=$(awk '/Mem:/ {l=5242880;print((s=$2/2)<l)?$2-l:s}' /proc/meminfo)
size=$(awk '/MemTotal:/ {l=5242880;mt=($2*1024);print((s=mt/2)<l)?mt-l:s}' /proc/meminfo)
mount none /tmp -t tmpfs -o size=$size,nosuid,nodev,mode=1777
if grep devfs /proc/filesystems >/dev/null; then
mount none /dev -t devfs
else
@ -13,7 +14,9 @@ else
mknod /dev/console c 5 1
exec >/dev/console </dev/console 2>&1
fi
mkdir /dev/shm
if grep sysfs /proc/filesystems >/dev/null; then
mount -t sysfs none /sys
HOTPLUG=""
@ -27,14 +30,25 @@ echo "$HOTPLUG" > /proc/sys/kernel/hotplug
mkdir -p /dev/pts
mount none /dev/pts -t devpts
jffs2_ready () {
mtdpart="$(find_mtd_part rootfs_data)"
magic=$(hexdump $mtdpart -n 4 -e '4/1 "%02x"')
[ "$magic" != "deadc0de" ]
}
[ failsafe != "$1" ] && {
grep rootfs /proc/mtd >/dev/null 2>/dev/null && {
mtd unlock rootfs
grep rootfs_data /proc/mtd >/dev/null 2>/dev/null && {
. /bin/firstboot
echo "switching to jffs2"
mount "$(find_mtd_part rootfs_data)" /jffs -t jffs2
fopivot /jffs /rom
jffs2_ready && {
echo "switching to jffs2"
mount "$(find_mtd_part rootfs_data)" /jffs -t jffs2
fopivot /jffs /rom
} || {
echo "jffs2 not ready yet; using ramdisk"
ramoverlay
}
}
} || mount -o remount,rw /dev/root /
}

@ -1,9 +0,0 @@
#!/bin/sh /etc/rc.common
# Copyright (C) 2007 OpenWrt.org
START=95
boot() {
# set leds to normal state
. /etc/diag.sh
set_state done
}

@ -1,9 +0,0 @@
#!/bin/sh /etc/rc.common
# Copyright (C) 2007 OpenWrt.org
START=95
boot() {
# set leds to normal state
. /etc/diag.sh
set_state done
}

@ -1,12 +1,9 @@
define Build/Compile
$(call Build/Compile/Default)
$(TARGET_CC) -I $(PLATFORM_DIR)/src -o $(PKG_BUILD_DIR)/jffs2root $(PLATFORM_DIR)/src/jffs2root.c
endef
define Package/base-files/install-target
rm -f $(1)/etc/config/network
mkdir -p $(1)/sbin
$(CP) $(PKG_BUILD_DIR)/jffs2root $(1)/sbin
endef

@ -1,128 +0,0 @@
#!/bin/sh
# $Id$
. /etc/functions.sh
partname="rootfs_data"
mtdpart="$(find_mtd_part $partname)"
rom=$(awk '/squashfs/ {print $2}' /proc/mounts)
jffs=$(awk '/jffs2/ {print $2}' /proc/mounts)
dupe() { # <new_root> <old_root>
cd $1
echo -n "creating directories... "
{
cd $2
find . -xdev -type d
echo "./dev ./jffs ./mnt ./proc ./tmp"
# xdev skips mounted directories
cd $1
} | xargs mkdir -p
echo "done"
echo -n "setting up symlinks... "
for file in $(cd $2; find . -xdev -type f;); do
case "$file" in
./rom/note) ;; #nothing
./etc/config*|\
./usr/lib/ipkg/info/*) cp -af $2/$file $file;;
*) ln -sf /rom/${file#./*} $file;;
esac
done
for file in $(cd $2; find . -xdev -type l;); do
cp -af $2/${file#./*} $file
done
echo "done"
}
pivot() { # <new_root> <old_root>
mount -o move /proc $1/proc && \
pivot_root $1 $1$2 && {
mount -o move $2/dev /dev
mount -o move $2/tmp /tmp
mount -o move $2/jffs /jffs 2>&-
return 0
}
}
fopivot() { # <rw_root> <ro_root> <dupe?>
root=$1
{
mount -t mini_fo -o base=/,sto=$1 $1 /mnt 2>&- && root=/mnt
} || {
[ "$3" = "1" ] && {
mount | grep "on $1 type" 2>&- 1>&- || mount -o bind $1 $1
dupe $1 $rom
}
}
pivot $root $2
}
ramoverlay() {
mkdir -p /tmp/root
fopivot /tmp/root /rom 1
}
# invoked as an executable
[ "${0##*/}" = "firstboot" ] && {
[ -z "$mtdpart" ] && {
echo "MTD partition not found."
exit 1
}
[ -z "$rom" ] && {
echo "You do not have a squashfs partition; aborting"
echo "(firstboot cannot be run on jffs2 based firmwares)"
exit 1
}
[ "$1" = "switch2jffs" ] && {
mtd erase "$partname"
# try to avoid fs changing while copying
mount -o remount,ro none / 2>&-
# copy ramoverlay to jffs2
mount "$mtdpart" /rom/jffs -t jffs2
echo -n "copying files ... "
cp -a /tmp/root/* /rom/jffs 2>&-
echo "done"
# switch back to squashfs (temporarily)
# and park the ramdisk ontop of /tmp/root
pivot /rom /mnt
mount -o move /mnt /tmp/root
# /jffs is the overlay
# /rom is the readonly
fopivot /jffs /rom
# try to get rid of /tmp/root
# this will almost always fail
umount /tmp/root 2>&-
# fs is clean
jffs2root --clean
exit 0
}
# script run manually
[ \! -z "$jffs" ] && {
echo "firstboot has already been run"
echo "jffs2 partition is mounted, only resetting files"
grep mini_fo /proc/filesystems >&-
[ $? != 0 ] && {
dupe $jffs $rom
exit 0
} || {
rm -rf $jffs/* 2>&-
mount -o remount $jffs / 2>&-
exit 0
}
}
mtd erase "$partname"
mount "$mtdpart" /jffs -t jffs2
fopivot /jffs /rom 1
}

@ -1,11 +1,12 @@
#!/bin/sh
# Copyright (C) 2006 OpenWrt.org
. /etc/functions.sh
. /etc/diag.sh
failsafe_ip() {
ifconfig $ifname 192.168.1.1 netmask 255.255.255.0 broadcast 192.168.1.255 up
}
failsafe() {
lock /tmp/.failsafe
failsafe_ip
echo "0 1 2 3 4 5u*" > /proc/switch/eth0/vlan/0/ports
@ -23,10 +24,8 @@ failsafe() {
ash --login
}
export PATH=/bin:/sbin:/usr/bin:/usr/sbin
mount none /proc -t proc
size=$(awk '/Mem:/ {l=5242880;print((s=$2/2)<l)?$2-l:s}' /proc/meminfo)
mount none /tmp -t tmpfs -o size=$size
if grep devfs /proc/filesystems > /dev/null; then
mount none /dev -t devfs
M0=/dev/pty/m0
@ -66,7 +65,7 @@ case "$(cat /proc/diag/model)" in
"ASUS (unknown, BCM4702)") ifname=eth1;;
esac
ifconfig $ifname 192.168.1.1 netmask 255.255.255.0 broadcast 192.168.1.255 up
failsafe_ip
insmod switch-core
insmod switch-robo || insmod switch-adm || rmmod switch-core
@ -83,14 +82,6 @@ insmod switch-robo || insmod switch-adm || rmmod switch-core
} || netmsg 192.168.1.255 "Press reset now, to enter Failsafe!"
sleep 2
eval ${FAILSAFE:+failsafe}
lock -w /tmp/.failsafe
set_state preinit
echo "$HOTPLUG" > /proc/sys/kernel/hotplug
ifconfig $ifname 0.0.0.0 down
mount_root
exec /sbin/init

@ -1,29 +0,0 @@
#!/bin/sh
# Copyright (C) 2006 OpenWrt.org
. /etc/functions.sh
is_dirty() {
mtdpart="$(find_mtd_part linux)"
grep Broadcom /proc/cpuinfo >&- || return 1
OFFSET="$(($(hexdump -v $mtdpart -s 20 -n 2 -e '"%d"')-1))"
return $(hexdump -v $mtdpart -s $OFFSET -n 1 -e '"%d"')
}
if [ "$1" != "failsafe" ]; then
mtd unlock linux
mount | grep jffs2 >&-
if [ $? = 0 ] ; then
mount -o remount,rw /dev/root /
else
. /bin/firstboot
is_dirty
[ $? != 0 ] && {
echo "switching to jffs2"
mount $(find_mtd_part rootfs_data) /jffs -t jffs2
fopivot /jffs /rom
} || {
echo "jffs2 not ready yet; using ramdisk"
ramoverlay
}
fi
fi

@ -50,7 +50,12 @@ define trxalign/squashfs
-a 1024
endef
define Image/Build/squashfs
$(call prepare_generic_squashfs,$(KDIR)/root.squashfs)
endef
define Image/Build
$(call Image/Build/$(1))
$(STAGING_DIR)/bin/trx -o $(BIN_DIR)/openwrt-$(BOARD)-$(KERNEL)-$(1).trx -f $(KDIR)/loader.gz -f $(KDIR)/vmlinux.lzma $(call trxalign/$(1)) -f $(KDIR)/root.$(1)
ifneq ($(1),jffs2-128k)
$(call Image/Build/CyberTAN,$(1),wrt54g3g,W54F,2.01.1,$(patsubst jffs2-%,jffs2,$(1)))

@ -1,138 +0,0 @@
/*
* jffs2root.c
*
* Copyright (C) 2005 Mike Baker
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*
* $Id$
*
*/
#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <string.h>
#include <sys/ioctl.h>
#include "mtd.h"
struct trx_header {
unsigned magic; /* "HDR0" */
unsigned len; /* Length of file including header */
unsigned crc32; /* 32-bit CRC from flag_version to end of file */
unsigned flag_version; /* 0:15 flags, 16:31 version */
unsigned offsets[3]; /* Offsets of partitions from start of header */
};
unsigned long *crc32;
void init_crc32()
{
unsigned long crc;
unsigned long poly = 0xEDB88320L;
int n, bit;
if ((crc32 = (unsigned long *) malloc(256 * sizeof(unsigned long))) == (void *)-1) {
perror("malloc");
exit(1);
}
for (n = 0; n < 256; n++) {
crc = (unsigned long) n;
for (bit = 0; bit < 8; bit++)
crc = (crc & 1) ? (poly ^ (crc >> 1)) : (crc >> 1);
crc32[n] = crc;
}
}
unsigned int crc32buf(char *buf, size_t len)
{
unsigned int crc = 0xFFFFFFFF;
for (; len; len--, buf++)
crc = crc32[(crc ^ *buf) & 0xff] ^ (crc >> 8);
return crc;
}
int main(int argc, char **argv)
{
int fd;
struct mtd_info_user mtdInfo;
unsigned long len;
struct trx_header *ptr;
char *buf;
if ((fd = open("/dev/mtdblock/1", O_RDWR)) < 0) {
fd = open("/dev/mtdblock1", O_RDWR);
}
if (((len = lseek(fd, 0, SEEK_END)) < 0)
|| ((ptr = (struct trx_header *) mmap(0, len, PROT_READ|PROT_WRITE, MAP_SHARED, fd, 0)) == (void *) (-1))
|| (ptr->magic != 0x30524448)) {
printf("Error reading trx info\n");
exit(-1);
}
close(fd);
if ((fd = open("/dev/mtd/1", O_RDWR)) < 0) {
fd = open("/dev/mtd1", O_RDWR);
}
if (ioctl(fd, MEMGETINFO, &mtdInfo)) {
fprintf(stderr, "Could not get MTD device info from mtd\n");
close(fd);
exit(1);
}
close(fd);
if (argc > 1 && !strcmp(argv[1],"--move")) {
if (ptr->offsets[2] >= ptr->len) {
printf("Partition already moved outside trx\n");
} else {
init_crc32();
ptr->offsets[2] += (mtdInfo.erasesize - 1);
ptr->offsets[2] &= ~(mtdInfo.erasesize - 1);
ptr->len = ptr->offsets[2];
ptr->crc32 = crc32buf((void *) &(ptr->flag_version), ptr->len - offsetof(struct trx_header, flag_version));
msync(ptr,sizeof(struct trx_header),MS_SYNC|MS_INVALIDATE);
printf("Partition moved; please reboot\n");
}
} else if (argc > 1 && !strcmp(argv[1], "--clean")) {
buf = (char *) ptr;
if (buf[ptr->offsets[1] - 1] == 0) {
init_crc32();
buf[ptr->offsets[1] - 1] = 1;
ptr->crc32 = crc32buf((void *) &(ptr->flag_version), ptr->len - offsetof(struct trx_header, flag_version));
msync(ptr,sizeof(struct trx_header),MS_SYNC|MS_INVALIDATE);
printf("Partition marked as clean\n");
}
} else {
int x;
printf(" erase: 0x%08x\n",mtdInfo.erasesize);
printf("=== trx ===\n");
printf("mapped: 0x%08x\n", (unsigned)ptr);
printf(" magic: 0x%08x\n", ptr->magic);
printf(" len: 0x%08x\n", ptr->len);
printf(" crc: 0x%08x\n", ptr->crc32);
for (x = 0; x < 3; x++)
printf(" offset[%d]: 0x%08x\n", x, ptr->offsets[x]);
}
munmap((void *) ptr, len);
return 0;
}
Loading…
Cancel
Save